{---------------------------------
         Delete Spaces
         LidaEd
 : 1.0
 :  
 E-Mail: alois1981@mail.ru
 Internet: http://www.alois.com.ru

---------------------------------}


library del_spaces;


function DelChars(const S: string; Chr: Char): string;
var
  I: Integer;
begin
  Result := S;
  for I := Length(Result) downto 1 do begin
    if Result[I] = Chr then Delete(Result, I, 1);
  end;
end;

function GetMenuCaption: PChar;
begin
  Result := ' ';
end;


function GetPluginInfo(ParentHandle: integer;
  var Name, Author, Version, Email, Web, AdditionalInfo: PChar
  ): integer;
begin
  Name := ' ';
  Author := ' ';
  Version := '1.0';
  Email := 'alois1981@mail.ru';
  Web := 'http://www.alois.com.ru';
  AdditionalInfo := '     .';
  Result := 0;
end;


function HandleData(ParentHandle : integer;
                          FileName : PChar;
                      var SelText, AllText, ErrorText : PChar;
                      var CaretX, CaretY : integer
                      ) : integer;
var
  txt: string;
begin
  if Length(SelText) = 0 then
  begin
    ErrorText := PChar('    !');
    Result := 0;
    exit;
  end;
  txt := SelText;
  txt := DelChars(txt, ' ');
  getmem(SelText, length(PChar(txt)));
  SelText := PChar(txt);
  Result := 1;
end;


exports
  GetMenuCaption,
  GetPluginInfo,
  HandleData;

begin
end.

