{---------------------------------
         HTML Change
         KoEdit
 : 1.0
 :   /Niko/
 e-Mail: nikosoft@box.vsi.ru
 www: http://www.coderpro.fatal.ru

---------------------------------}


library html_change;

function GetMenuCaption: PChar;
begin
  Result := 'HTML  ';
end;


function GetPluginInfo(ParentHandle: integer;
  var Name, Author, Version, Email, Web, AdditionalInfo: PChar
  ): integer;
begin
  Name := 'HTML Change';
  Author := '  /Niko/';
  Version := '1.0';
  Email := 'nikosoft@box.vsi.ru';
  Web := 'http://www.coderpro.fatal.ru';
  AdditionalInfo := '     ''<''   &lt;,'+
  ' ''>''  &gt;   ''&''  &amp;.      <br />';
  Result := 0;
end;


function HandleData(ParentHandle : integer;
                          FileName : PChar;
                      var SelText, AllText, ErrorText : PChar;
                      var CaretX, CaretY : integer
                      ) : integer;
var
  i: int64;
  txt: string;
begin
  if Length(SelText) = 0 then
  begin
    ErrorText := PChar('    !');
    Result := 8;
    exit;
  end;
  i := 1;
  txt := SelText;
  while i <= length(txt) do
  begin
    if txt[i] = '&' then
      txt := copy(txt, 1, i - 1) + '&amp;' + copy(txt, i + 1, length(txt) - i);
    if txt[i] = '<' then
      txt := copy(txt, 1, i - 1) + '&lt;' + copy(txt, i + 1, length(txt) - i);
    if txt[i] = '>' then
      txt := copy(txt, 1, i - 1) + '&gt;' + copy(txt, i + 1, length(txt) - i);
    if txt[i] = chr(13) then
    begin
      txt := copy(txt, 1, i - 1) + '<br />' + copy(txt, i, length(txt) - i + 1);
      inc(i, 6);
    end;
    inc(i);
  end;
  getmem(SelText, length(PChar(txt)));
  SelText := PChar(txt);
  Result := 1;
end;


exports
  GetMenuCaption,
  GetPluginInfo,
  HandleData;

begin
end.

