{ Created: 15.03.2003 0:10:48 by keYer }
library html_color;

uses
  Windows,{ Messages,} CommDlg;


  function GetMenuCaption : PChar;
  begin
    Result := ' HTML ';
  end;


  function GetPluginInfo(
                             ParentHandle : integer;
                         var Name, Author, Version, Email, Web, AdditionalInfo : PChar
                         ) : integer;
  begin
    Name := 'HTML_COLOR';
    Author := ' ';
    Version := '1.1';
    Email := 'keyer7@mail.ru';
    Web := 'http://ournet.md/~KoEdit';
    AdditionalInfo := '       , '+
                      '      RGB  (#XXXXXX)!';
    Result := 0;
  end;

  function dec2hex(dec : longint) : string;
  const
    hexdigts : string[16] = '0123456789abcdef';
  var
    hex : string;
    i, j : longint;
  begin
    if dec = 0 then
      hex := '00'
    else begin
      hex := '';
      i := 0;
      while (1 shl ((i + 1) * 4)) <=dec do
        i := i + 1;
      for j := 0 to i do begin
        hex := hex + hexdigts[(dec shr ((i - j) * 4)) + 1];
        dec := dec and ((1 shl ((i - j) * 4)) - 1);
      end;
    end;
    if length(hex) = 1 then
      insert('0', hex, 1);
    dec2hex := hex;
  end;


  function HandleData(ParentHandle : integer;
                          FileName : PChar;
                      var SelText, AllText, ErrorText : PChar;
                      var CaretX, CaretY : integer
                      ) : integer;
  var
    cl : TCHOOSECOLOR;
    CustomColors : array[0..16]of ColorRef;
    i : byte;
  begin
    fillchar(cl, sizeof(TCHOOSECOLOR), 0);
    for i := 16 downto 0 do
      CustomColors[i] := GetSysColor(i);
    with cl do begin
      lStructSize := sizeof(TCHOOSECOLOR);
      hWndOwner := ParentHandle;
      hInstance := hInstance;
      Flags := CC_FULLOPEN or CC_RGBINIT;
      lpCustColors:=@CustomColors;
      rgbResult := 0;
    end;
    if ChooseColor(cl) then begin
      getmem(SelText, 8);
      SelText[0] := '#';
      SelText[1] := #0;
      lstrcat(SelText, PChar(dec2hex(getRvalue(cl.rgbResult))));
      lstrcat(SelText, PChar(dec2hex(getGvalue(cl.rgbResult))));
      lstrcat(SelText, PChar(dec2hex(getBvalue(cl.rgbResult))));
      Result := 1;
    end else
      Result := 5;
  end;


exports
  GetMenuCaption,
  GetPluginInfo,
  HandleData;

begin
end.
