{---------------------------------
         Text Information
         LidaEd
 : 1.0
 :  
 E-Mail: alois1981@mail.ru
 Internet: http://www.alois.com.ru

---------------------------------}


library text_info;

uses Windows, KOL;

Type TCharSet = set of char;

function DelChars(const S: string; Chr: Char): string;
var
  I: Integer;
begin
  Result := S;
  for I := Length(Result) downto 1 do begin
    if Result[I] = Chr then Delete(Result, I, 1);
  end;
end;

function WordCount(const S: string; const WordDelims: TCharSet): Integer;
var
  SLen, I: Cardinal;
begin
  Result := 0;
  I := 1;
  SLen := Length(S);
  while I <= SLen do begin
    while (I <= SLen) and (S[I] in WordDelims) do Inc(I);
    if I <= SLen then Inc(Result);
    while (I <= SLen) and not(S[I] in WordDelims) do Inc(I);
  end;
end;

function GetMenuCaption: PChar;
begin
  Result := '  ';
end;

function GetPluginInfo(ParentHandle: integer;
  var Name, Author, Version, Email, Web, AdditionalInfo: PChar
  ): integer;
begin
  Name := '  ';
  Author := ' ';
  Version := '1.0';
  Email := 'alois1981@mail.ru';
  Web := 'http://www.alois.com.ru';
  AdditionalInfo := '   ';
  Result := 0;
end;


function HandleData(ParentHandle : integer;
                          FileName : PChar;
                      var SelText, AllText, ErrorText : PChar;
                      var CaretX, CaretY : integer
                      ) : integer;
var
txt: string;

begin
  txt:='  (): '+Int2Str(Length(SelText))+#10#13;
  txt:=txt+'  ( ): '+Int2Str(Length(DelChars(SelText, ' ')))+#10#13;
  txt:=txt+' : '+Int2Str(WordCount(SelText, [' ', #13]));
  MessageBox(ParentHandle, PChar(txt), '  ', MB_OK);
  Result := 0;
end;


exports
  GetMenuCaption,
  GetPluginInfo,
  HandleData;

begin
end.

