///////////////////////////////////////////////////////////////////////////////////////
//  :                            //
//  :  . ., sergjp@rambler.ru    2001.                          //
// :                                                                         //
//            by_words(n)  ,     n              //
//                .    ,  //
//                    ,      //
//               CURRENCY_SHORT_NAME                             //
//               CHANGE_SHORT_NAME                                    //
//   : FreeWare                                                //
//   : Delphi 7                                                     //
///////////////////////////////////////////////////////////////////////////////////////
unit ByWords;

interface

const
   CURRENCY_SHORT_NAME = '.';
   CHANGE_SHORT_NAME   = '.';

function by_words(n: double) : AnsiString;

implementation
uses SysUtils,Math,StrUtils;

function triad(tr : string; fem :boolean) : string;
var
   first,second,third : char;
begin
   Result := '';
   first  := tr[1];
   second := tr[2];
   third  := tr[3];

   if not (first in ['0'..'9'])  then first := '0';
   if not (second in ['0'..'9']) then second := '0';
   if not (third in ['0'..'9'])  then third := '0';
   case third of
     '1' : if fem then Result := '' else Result := '';
     '2' : if fem then Result := ''  else Result := '';
     '3' : Result := '';
     '4' : Result := '';
     '5' : Result := '';
     '6' : Result := '';
     '7' : Result := '';
     '8' : Result := '';
     '9' : Result := '';
   end;
   case second of
   '1' : begin
                  case third of
                     '0' : Result := '';
                     '1' : Result := ' ';
                     '2' : Result := ' ';
                     '3' : Result := ' ' ;
                     '4' : Result := ' ';
                     '5' : Result := ' ';
                     '6' : Result := ' ';
                     '7' : Result := ' ';
                     '8' : Result := ' ';
                     '9' : Result := ' ';
                  end
         end;
     '2' : Result := ' ' + Result;
     '3' : Result := ' ' + Result;
     '4' : Result := ' '    + Result;
     '5' : Result := ' ' + Result;
     '6' : Result := ' ' + Result;
     '7' : Result := ' ' + Result;
     '8' : Result := ' ' + Result;
     '9' : Result := ' ' + Result;
   end;
   case first of
   '1' : Result := ' ' + Result;
   '2' : Result := ' ' + Result;
   '3' : Result := ' ' + Result;
   '4' : Result := ' ' + Result;
   '5' : Result := ' ' + Result;
   '6' : Result := ' ' + Result;
   '7' : Result := ' ' + Result;
   '8' : Result := ' ' + Result;
   '9' : Result := ' ' + Result;
   end
end;


function padezh(tr : string; deg : byte) : string;
begin
  Result := '';
  if ((tr[3] in ['1'..'9']) and (tr[2] = '1')) or (tr[3] = '0') then begin
//  11-19    
     case deg of
     1 : Result := '  ';
     2 : Result := '  ';
     3 : Result := '  ';
     end;
     Exit;
  end;
  case tr[3] of
  '1' : begin
           case deg of
           1 : Result := '  ';
           2 : Result := '  ';
           3 : Result := '  ';
           end
        end;
  '2' ,
  '3' ,
  '4' :
        begin
           case deg of
           1 : Result := '  ';
           2 : Result := '  ';
           3 : Result := '  ';
           end
        end
    else  begin
           case deg of
           1 : Result := '  ';
           2 : Result := '  ';
           3 : Result := '  ';
           end
          end

  end;
end;


function by_words(n : double) : string;
var
   tr,otr,sn : string;
   res : string;               // 
   por : string;               // 
   deg : byte;
   fem : boolean;             //   
   int, frac : Int64;            //    
begin
  if n = 0 then begin
     Result := '';
     Exit;
  end;
  res := ' ';   por := ''; deg := 0; //fem := false;
//      
   n := RoundTo(n,-3);
   int := Trunc(n);
   frac := Round((n - int)*100);
   sn := IntToStr(int);

   while length(sn) > 0 do begin
//  3   
     if length(sn) < 3 then begin
       tr := sn;
       sn := ''  //   
     end
     else begin
       tr := RightStr(sn,3);       
       Delete(sn,length(sn)-2,3);
     end;

     case length(tr) of
     1 : tr := '00' + tr;
     2 : tr := '0' + tr;
     end;
     por := padezh(tr,deg);
     fem := deg = 1;
     otr := triad(tr,fem);
     if otr <> '' then res := otr +  por +  res;
     Inc(deg);
   end;
//     
   sn := res[1];
   res := AnsiUpperCase(sn)+Copy(res,2,Length(res));
   Result := res + ' ' + CURRENCY_SHORT_NAME + ' ' + Format('%.2d',[frac]) + ' ' + CHANGE_SHORT_NAME;
end;




end.

