{---------------------------------
         Int To Words
         LidaEd
 : 1.0
 :  
 E-Mail: alois1981@mail.ru
 Internet: http://www.alois.com.ru

---------------------------------}


library html_change;

uses ByWords;


function is_num(s: string; nt: byte): boolean;
const
  dec_chars = ['1', '2', '3', '4', '5', '6', '7', '8', '9', '0'];
  bin_chars = ['1', '0'];
  hex_chars = ['1', '2', '3', '4', '5', '6', '7', '8', '9', '0', 'A', 'B', 'C', 'D', 'E', 'F'];
  oct_chars = ['1', '2', '3', '4', '5', '6', '7', '0'];
var
  i: longint;
  c: set of char;
begin
  result := true;
  case nt of
    0: c := dec_chars;
    1: c := bin_chars;
    2: c := hex_chars;
    3: c := oct_chars;
  end;
  for i := 1 to length(s) do
    if not (upcase(s[i]) in c) then begin
      result := false;
      break;
    end;
end;

function GetMenuCaption: PChar;
begin
  Result := ' ';
end;


function GetPluginInfo(ParentHandle: integer;
  var Name, Author, Version, Email, Web, AdditionalInfo: PChar
  ): integer;
begin
  Name := ' ';
  Author := ' ';
  Version := '1.0';
  Email := 'alois1981@mail.ru';
  Web := 'http://www.alois.com.ru';
  AdditionalInfo := '     ';
  Result := 0;
end;


function HandleData(ParentHandle : integer;
                          FileName : PChar;
                      var SelText, AllText, ErrorText : PChar;
                      var CaretX, CaretY : integer
                      ) : integer;
var
  Code: Integer;
  I: real;
  txt: string;
begin
  if Length(SelText) = 0 then
  begin
    ErrorText := PChar('    !');
    Result := 0;
    exit;
  end;
  txt := SelText;
  if is_num(txt, 0) then begin
  Val(txt, I, Code);
  txt := By_Words(I);
  getmem(SelText, length(PChar(txt)));
  end;
  SelText := PChar(txt);
  Result := 1;
end;


exports
  GetMenuCaption,
  GetPluginInfo,
  HandleData;

begin
end.

